
/* simple debuggin interface to serialize output ... 
 * should be rewritten to do large chunks of operations 
 */

#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>

#include <linux/ulocks.h>  // need comapre_and_swap

#define YYDEBUG_BUFFERED 1

#if YYDEBUG_BUFFERED

int yyprintf(const char *fmt, ...)
{
	char msg[120];
	int cnt;
	static unsigned long mylock = 0;
	static unsigned long seqn = 0;

        va_list args;
        va_start(args, fmt);
	atomic_inc((atomic_t*)&seqn);
	cnt = sprintf(msg,"%8d ",seqn);
        vsprintf(msg+cnt, fmt, args);
	do {} while (__compare_and_swap(&mylock,0,1));
	fputs(msg,stdout);
	mylock = 0;
	va_end(args);
}

void yyflush(int final) { }

#else

#define YYBUFSIZE (1<<24)

char yybuf[YYBUFSIZE];
char *yyc=yybuf;
char *yye=&yybuf[YYBUFSIZE-128];

void yyflush(int final)
{
	static numflush = 0;
	static unsigned long nbytes = 0;
	if ((yyc > yye) || final) {
//		write(,yybuf,yyc-yybuf);
		fwrite(yybuf,yyc-yybuf,1,stdout);
		fflush(stdout);
		nbytes += (yyc - yybuf);
		yyc = yybuf;
		numflush++;
	}
	if (final) {
		printf("=========== flushes %d %ld ==========\n",numflush-1,nbytes);
		sleep(1);
	}
}

int yyprintf(const char *fmt, ...)
{
	int   cnt;
	static unsigned long mylock = 0;
	static unsigned long seqn = 0;

        va_list args;
        va_start(args, fmt);
	do {} while (__compare_and_swap(&mylock,0,1));
	seqn++;
//	atomic_inc((atomic_t*)&seqn);
	yyc += sprintf(yyc,"> %8d ",seqn);
        yyc += vsprintf(yyc, fmt, args);
	if (yyc > yye) yyflush(0);
	mylock = 0;
	va_end(args);
}

#endif


